__gnu_debug::basic_string< _CharT, _Traits, _Allocator > Class Template Reference

`#include <string>`

Inheritance diagram for __gnu_debug::basic_string< _CharT, _Traits, _Allocator >:
[legend]

## Public Types

typedef _Allocator | allocator_type
typedef __gnu_debug::_Safe_iterator< typename _Base::const_iterator, basic_string > | const_iterator
typedef _Base::const_pointer | const_pointer
typedef _Base::const_reference | const_reference
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef _Base::difference_type | difference_type
typedef __gnu_debug::_Safe_iterator< typename _Base::iterator, basic_string > | iterator
typedef _Base::pointer | pointer
typedef _Base::reference | reference
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef _Base::size_type | size_type
typedef _Traits | traits_type
typedef _Traits::char_type | value_type

## Public Member Functions

| basic_string (_Base &&__base) noexcept
template<typename _InputIterator>
| basic_string (_InputIterator __begin, _InputIterator __end, const _Allocator &__a=_Allocator())
| basic_string (basic_string &&)=default
| basic_string (basic_string &&__s, const _Allocator &__a) noexcept(std::is_nothrow_constructible< _Base, _Base, const _Allocator & >::value)
| basic_string (const _Allocator &__a) noexcept
| basic_string (const _Base &__base)
| basic_string (const _CharT *__s, const _Allocator &__a=_Allocator())
| basic_string (const _CharT *__s, size_type __n, const _Allocator &__a=_Allocator())
| basic_string (const basic_string &)=default
| basic_string (const basic_string &__s, const _Allocator &__a)
| basic_string (const basic_string &__str, size_type __pos, size_type __n=_Base::npos, const _Allocator &__a=_Allocator())
| basic_string (size_type __n, _CharT __c, const _Allocator &__a=_Allocator())
| basic_string (std::initializer_list< _CharT > __l, const _Allocator &__a=_Allocator())
template<typename _Operation>
constexpr void | __resize_and_overwrite (size_type __n, _Operation __op)
template<typename _Operation>
void | __resize_and_overwrite (size_type __n, _Operation __op)
const _Base & | _M_base () const noexcept
_Base & | _M_base () noexcept
template<typename _InputIterator>
basic_string< _CharT, _Traits, _Alloc > & | _M_replace_dispatch (iterator __i1, iterator __i2, _InputIterator __k1, _InputIterator __k2, __false_type)
template<typename _InIterator>
_CharT * | _S_construct (_InIterator __beg, _InIterator __end, const _Alloc &__a, forward_iterator_tag)
template<typename _InputIterator>
basic_string & | append (_InputIterator __first, _InputIterator __last)
basic_string & | append (const _CharT *__s)
basic_string & | append (const _CharT *__s, size_type __n)
basic_string & | append (const basic_string &__str)
basic_string & | append (const basic_string &__str, size_type __pos, size_type __n)
basic_string & | append (size_type __n, _CharT __c)
constexpr basic_string & | append (const _CharT *__s, size_type __n)
constexpr basic_string & | append (const basic_string &__str)
constexpr basic_string & | append (const basic_string &__str, size_type __pos, size_type __n=npos)
constexpr basic_string & | append (initializer_list< _CharT > __l)
constexpr basic_string & | append (size_type __n, _CharT __c)
template<typename _InputIterator>
basic_string & | assign (_InputIterator __first, _InputIterator __last)
basic_string & | assign (basic_string &&__x) noexcept(noexcept(std::declval< _Base & >().assign(std::move(__x))))
basic_string & | assign (const _CharT *__s)
basic_string & | assign (const _CharT *__s, size_type __n)
basic_string & | assign (const basic_string &__str, size_type __pos, size_type __n)
basic_string & | assign (const basic_string &__x)
basic_string & | assign (size_type __n, _CharT __c)
basic_string & | assign (std::initializer_list< _CharT > __l)
constexpr basic_string & | assign (basic_string &&__str) noexcept(_Alloc_traits::_S_nothrow_move())
constexpr basic_string & | assign (const _CharT *__s, size_type __n)
constexpr basic_string & | assign (const basic_string &__str)
constexpr basic_string & | assign (const basic_string &__str, size_type __pos, size_type __n=npos)
constexpr basic_string & | assign (size_type __n, _CharT __c)
constexpr reference | at (size_type __n)
reference | at (size_type __n)
constexpr const_reference | at (size_type __n) const
const_reference | at (size_type __n) const
constexpr reference | at (size_type __n)
constexpr const_reference | at (size_type __n) const
constexpr const_reference | back () const noexcept
constexpr reference | back () noexcept
iterator | begin ()
const_iterator | begin () const noexcept
const _CharT * | c_str () const noexcept
constexpr size_type | capacity () const noexcept
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
void | clear ()
constexpr int | compare (const _CharT *__s) const noexcept
constexpr int | compare (const basic_string &__str) const
constexpr int | compare (size_type __pos, size_type __n, const basic_string &__str) const
int | compare (size_type __pos, size_type __n, const basic_string &__str) const
constexpr int | compare (size_type __pos, size_type __n1, const _CharT *__s) const
constexpr int | compare (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2) const
int | compare (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2) const
constexpr int | compare (size_type __pos1, size_type __n1, const _CharT *__s) const
constexpr int | compare (size_type __pos1, size_type __n1, const _CharT *__s, size_type __n2) const
constexpr int | compare (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2=npos) const
int | compare (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2=npos) const
constexpr int | compare (size_type __pos, size_type __n, const basic_string &__str) const
constexpr int | compare (size_type __pos, size_type __n1, const _CharT *__s) const
constexpr int | compare (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2) const
constexpr int | compare (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2=npos) const
size_type | copy (_CharT *__s, size_type __n, size_type __pos=0) const
constexpr size_type | copy (_CharT *__s, size_type __n, size_type __pos=0) const
const_reverse_iterator | crbegin () const noexcept
const_reverse_iterator | crend () const noexcept
const _CharT * | data () const noexcept
constexpr _CharT * | data () noexcept
constexpr bool | empty () const noexcept
iterator | end ()
const_iterator | end () const noexcept
constexpr bool | ends_with (_CharT __x) const noexcept
bool | ends_with (_CharT __x) const noexcept
constexpr bool | ends_with (basic_string_view< _CharT, _Traits > __x) const noexcept
bool | ends_with (basic_string_view< _CharT, _Traits > __x) const noexcept
constexpr bool | ends_with (const _CharT *__x) const noexcept
bool | ends_with (const _CharT *__x) const noexcept
iterator | erase (__const_iterator __first, __const_iterator __last)
iterator | erase (__const_iterator __position)
basic_string & | erase (size_type __pos=0, size_type __n=_Base::npos)
constexpr iterator | erase (__const_iterator __first, __const_iterator __last)
constexpr iterator | erase (__const_iterator __position)
iterator | erase (iterator __first, iterator __last)
iterator | erase (iterator __position)
constexpr basic_string & | erase (size_type __pos=0, size_type __n=npos)
constexpr size_type | find (_CharT __c, size_type __pos=0) const noexcept
size_type | find (_CharT __c, size_type __pos=0) const noexcept
constexpr size_type | find (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find (const _CharT *__s, size_type __pos, size_type __n) const noexcept
size_type | find (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find (const _CharT *__s, size_type __pos=0) const noexcept
constexpr size_type | find (const _CharT *__s, size_type __pos=0) const noexcept
constexpr size_type | find (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find (const basic_string &__str, size_type __pos=0) const noexcept
constexpr size_type | find (_CharT __c, size_type __pos=0) const noexcept
constexpr size_type | find (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find (const _CharT *__s, size_type __pos=0) const noexcept
constexpr size_type | find (const basic_string &__str, size_type __pos=0) const noexcept
constexpr size_type | find_first_not_of (_CharT __c, size_type __pos=0) const noexcept
size_type | find_first_not_of (_CharT __c, size_type __pos=0) const noexcept
constexpr size_type | find_first_not_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find_first_not_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
size_type | find_first_not_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find_first_not_of (const _CharT *__s, size_type __pos=0) const noexcept
constexpr size_type | find_first_not_of (const _CharT *__s, size_type __pos=0) const noexcept
constexpr size_type | find_first_not_of (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_first_not_of (const basic_string &__str, size_type __pos=0) const noexcept
constexpr size_type | find_first_not_of (_CharT __c, size_type __pos=0) const noexcept
constexpr size_type | find_first_not_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find_first_not_of (const _CharT *__s, size_type __pos=0) const noexcept
constexpr size_type | find_first_not_of (const basic_string &__str, size_type __pos=0) const noexcept
constexpr size_type | find_first_of (_CharT __c, size_type __pos=0) const noexcept
size_type | find_first_of (_CharT __c, size_type __pos=0) const noexcept
constexpr size_type | find_first_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find_first_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
size_type | find_first_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find_first_of (const _CharT *__s, size_type __pos=0) const noexcept
constexpr size_type | find_first_of (const _CharT *__s, size_type __pos=0) const noexcept
constexpr size_type | find_first_of (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_first_of (const basic_string &__str, size_type __pos=0) const noexcept
constexpr size_type | find_first_of (_CharT __c, size_type __pos=0) const noexcept
constexpr size_type | find_first_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find_first_of (const _CharT *__s, size_type __pos=0) const noexcept
constexpr size_type | find_first_of (const basic_string &__str, size_type __pos=0) const noexcept
constexpr size_type | find_last_not_of (_CharT __c, size_type __pos=npos) const noexcept
size_type | find_last_not_of (_CharT __c, size_type __pos=npos) const noexcept
constexpr size_type | find_last_not_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find_last_not_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
size_type | find_last_not_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find_last_not_of (const _CharT *__s, size_type __pos=_Base::npos) const noexcept
constexpr size_type | find_last_not_of (const _CharT *__s, size_type __pos=npos) const noexcept
constexpr size_type | find_last_not_of (const basic_string &__str, size_type __pos=npos) const noexcept
size_type | find_last_not_of (const basic_string &__str, size_type __pos=npos) const noexcept
constexpr size_type | find_last_not_of (_CharT __c, size_type __pos=npos) const noexcept
constexpr size_type | find_last_not_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find_last_not_of (const _CharT *__s, size_type __pos=npos) const noexcept
constexpr size_type | find_last_not_of (const basic_string &__str, size_type __pos=npos) const noexcept
constexpr size_type | find_last_of (_CharT __c, size_type __pos=npos) const noexcept
size_type | find_last_of (_CharT __c, size_type __pos=npos) const noexcept
constexpr size_type | find_last_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find_last_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
size_type | find_last_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find_last_of (const _CharT *__s, size_type __pos=_Base::npos) const noexcept
constexpr size_type | find_last_of (const _CharT *__s, size_type __pos=npos) const noexcept
constexpr size_type | find_last_of (const basic_string &__str, size_type __pos=npos) const noexcept
size_type | find_last_of (const basic_string &__str, size_type __pos=npos) const noexcept
constexpr size_type | find_last_of (_CharT __c, size_type __pos=npos) const noexcept
constexpr size_type | find_last_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find_last_of (const _CharT *__s, size_type __pos=npos) const noexcept
constexpr size_type | find_last_of (const basic_string &__str, size_type __pos=npos) const noexcept
constexpr const_reference | front () const noexcept
constexpr reference | front () noexcept
constexpr allocator_type | get_allocator () const noexcept
iterator | insert (__const_iterator __p, _CharT __c)
template<typename _InputIterator>
iterator | insert (__const_iterator __p, _InputIterator __first, _InputIterator __last)
iterator | insert (const_iterator __p, size_type __n, _CharT __c)
iterator | insert (const_iterator __p, std::initializer_list< _CharT > __l)
basic_string & | insert (size_type __pos, const _CharT *__s)
basic_string & | insert (size_type __pos, const _CharT *__s, size_type __n)
basic_string & | insert (size_type __pos, size_type __n, _CharT __c)
basic_string & | insert (size_type __pos1, const basic_string &__str)
basic_string & | insert (size_type __pos1, const basic_string &__str, size_type __pos2, size_type __n)
constexpr iterator | insert (__const_iterator __p, _CharT __c)
template<class _InputIterator, typename = std::_RequireInputIter<_InputIterator>>
constexpr iterator | insert (const_iterator __p, _InputIterator __beg, _InputIterator __end)
constexpr iterator | insert (const_iterator __p, initializer_list< _CharT > __l)
constexpr iterator | insert (const_iterator __p, size_type __n, _CharT __c)
iterator | insert (iterator __p, _CharT __c)
template<class _InputIterator>
void | insert (iterator __p, _InputIterator __beg, _InputIterator __end)
void | insert (iterator __p, initializer_list< _CharT > __l)
void | insert (iterator __p, size_type __n, _CharT __c)
constexpr basic_string & | insert (size_type __pos, const _CharT *__s)
constexpr basic_string & | insert (size_type __pos, const _CharT *__s, size_type __n)
constexpr basic_string & | insert (size_type __pos, size_type __n, _CharT __c)
constexpr basic_string & | insert (size_type __pos1, const basic_string &__str)
constexpr basic_string & | insert (size_type __pos1, const basic_string &__str, size_type __pos2, size_type __n=npos)
constexpr size_type | length () const noexcept
constexpr size_type | max_size () const noexcept
basic_string & | operator+= (_CharT __c)
basic_string & | operator+= (const _CharT *__s)
basic_string & | operator+= (const basic_string &__str)
basic_string & | operator+= (std::initializer_list< _CharT > __l)
constexpr basic_string & | operator+= (const basic_string &__str)
basic_string & | operator= (_CharT __c)
basic_string & | operator= (basic_string &&)=default
basic_string & | operator= (const _CharT *__s)
basic_string & | operator= (const basic_string &)=default
basic_string & | operator= (std::initializer_list< _CharT > __l)
reference | operator[] (size_type __pos)
const_reference | operator[] (size_type __pos) const noexcept
constexpr reference | operator[] (size_type __pos)
constexpr const_reference | operator[] (size_type __pos) const noexcept
void | pop_back ()
void | push_back (_CharT __c)
reverse_iterator | rbegin ()
const_reverse_iterator | rbegin () const noexcept
reverse_iterator | rend ()
const_reverse_iterator | rend () const noexcept
template<typename _InputIterator>
basic_string & | replace (__const_iterator __i1, __const_iterator __i2, _InputIterator __j1, _InputIterator __j2)
basic_string & | replace (__const_iterator __i1, __const_iterator __i2, const _CharT *__s)
basic_string & | replace (__const_iterator __i1, __const_iterator __i2, const _CharT *__s, size_type __n)
basic_string & | replace (__const_iterator __i1, __const_iterator __i2, const basic_string &__str)
basic_string & | replace (__const_iterator __i1, __const_iterator __i2, size_type __n, _CharT __c)
basic_string & | replace (__const_iterator __i1, __const_iterator __i2, std::initializer_list< _CharT > __l)
basic_string & | replace (size_type __pos, size_type __n1, const _CharT *__s)
basic_string & | replace (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2)
basic_string & | replace (size_type __pos, size_type __n1, size_type __n2, _CharT __c)
basic_string & | replace (size_type __pos1, size_type __n1, const basic_string &__str)
basic_string & | replace (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2)
constexpr basic_string & | replace (__const_iterator __i1, __const_iterator __i2, _CharT *__k1, _CharT *__k2)
constexpr basic_string & | replace (__const_iterator __i1, __const_iterator __i2, const _CharT *__k1, const _CharT *__k2)
constexpr basic_string & | replace (__const_iterator __i1, __const_iterator __i2, const _CharT *__s)
constexpr basic_string & | replace (__const_iterator __i1, __const_iterator __i2, const _CharT *__s, size_type __n)
constexpr basic_string & | replace (__const_iterator __i1, __const_iterator __i2, const basic_string &__str)
constexpr basic_string & | replace (__const_iterator __i1, __const_iterator __i2, const_iterator __k1, const_iterator __k2)
constexpr basic_string & | replace (__const_iterator __i1, __const_iterator __i2, iterator __k1, iterator __k2)
constexpr basic_string & | replace (__const_iterator __i1, __const_iterator __i2, size_type __n, _CharT __c)
template<class _InputIterator, typename = std::_RequireInputIter<_InputIterator>>
constexpr basic_string & | replace (const_iterator __i1, const_iterator __i2, _InputIterator __k1, _InputIterator __k2)
constexpr basic_string & | replace (const_iterator __i1, const_iterator __i2, initializer_list< _CharT > __l)
basic_string & | replace (iterator __i1, iterator __i2, _CharT *__k1, _CharT *__k2)
template<class _InputIterator>
basic_string & | replace (iterator __i1, iterator __i2, _InputIterator __k1, _InputIterator __k2)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__k1, const _CharT *__k2)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__s)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__s, size_type __n)
basic_string & | replace (iterator __i1, iterator __i2, const basic_string &__str)
basic_string & | replace (iterator __i1, iterator __i2, const_iterator __k1, const_iterator __k2)
basic_string & | replace (iterator __i1, iterator __i2, initializer_list< _CharT > __l)
basic_string & | replace (iterator __i1, iterator __i2, iterator __k1, iterator __k2)
basic_string & | replace (iterator __i1, iterator __i2, size_type __n, _CharT __c)
constexpr basic_string & | replace (size_type __pos, size_type __n, const basic_string &__str)
constexpr basic_string & | replace (size_type __pos, size_type __n1, const _CharT *__s)
constexpr basic_string & | replace (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2)
constexpr basic_string & | replace (size_type __pos, size_type __n1, size_type __n2, _CharT __c)
constexpr basic_string & | replace (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2=npos)
constexpr void | reserve ()
constexpr void | reserve (size_type __res_arg)
void | reserve (size_type __res_arg)
constexpr void | reserve (size_type __res_arg)
void | resize (size_type __n)
void | resize (size_type __n, _CharT __c)
constexpr void | resize (size_type __n)
constexpr void | resize (size_type __n, _CharT __c)
constexpr size_type | rfind (_CharT __c, size_type __pos=npos) const noexcept
size_type | rfind (_CharT __c, size_type __pos=npos) const noexcept
constexpr size_type | rfind (const _CharT *__s, size_type __pos, size_type __n) const
constexpr size_type | rfind (const _CharT *__s, size_type __pos, size_type __n) const noexcept
size_type | rfind (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | rfind (const _CharT *__s, size_type __pos=_Base::npos) const
constexpr size_type | rfind (const _CharT *__s, size_type __pos=npos) const
constexpr size_type | rfind (const basic_string &__str, size_type __pos=npos) const noexcept
size_type | rfind (const basic_string &__str, size_type __pos=npos) const noexcept
constexpr size_type | rfind (_CharT __c, size_type __pos=npos) const noexcept
constexpr size_type | rfind (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | rfind (const _CharT *__s, size_type __pos=npos) const
constexpr size_type | rfind (const basic_string &__str, size_type __pos=npos) const noexcept
void | shrink_to_fit () noexcept
constexpr size_type | size () const noexcept
constexpr bool | starts_with (_CharT __x) const noexcept
bool | starts_with (_CharT __x) const noexcept
constexpr bool | starts_with (basic_string_view< _CharT, _Traits > __x) const noexcept
bool | starts_with (basic_string_view< _CharT, _Traits > __x) const noexcept
constexpr bool | starts_with (const _CharT *__x) const noexcept
bool | starts_with (const _CharT *__x) const noexcept
basic_string | substr (size_type __pos=0, size_type __n=_Base::npos) const
constexpr basic_string | substr (size_type __pos=0, size_type __n=npos) const
void | swap (basic_string &__x) noexcept(/*conditional */)
constexpr void | swap (basic_string &__s) noexcept

## Static Public Attributes

static const size_type | npos

## Protected Member Functions

constexpr void | _M_swap (_Safe_container &__x) noexcept

## Friends

template<typename _ItT, typename _SeqT, typename _CatT>
class | ::__gnu_debug::_Safe_iterator

## Detailed Description

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>
class __gnu_debug::basic_string< _CharT, _Traits, _Allocator >

Class std::basic_string with safety/checking/debug instrumentation.

Definition at line 131 of file debug/string.

## Member Typedef Documentation

## allocator_type

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

typedef _Allocator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::allocator_type

Definition at line 153 of file debug/string.

## const_iterator

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

typedef __gnu_debug::_Safe_iterator< typename _Base::const_iterator, basic_string> __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::const_iterator

Definition at line 164 of file debug/string.

## const_pointer

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

typedef _Base::const_pointer __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::const_pointer

Definition at line 159 of file debug/string.

## const_reference

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

typedef _Base::const_reference __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::const_reference

Definition at line 157 of file debug/string.

## const_reverse_iterator

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

typedef std::reverse_iterator<const_iterator> __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::const_reverse_iterator

Definition at line 167 of file debug/string.

## difference_type

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

typedef _Base::difference_type __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::difference_type

Definition at line 155 of file debug/string.

## iterator

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

typedef __gnu_debug::_Safe_iterator< typename _Base::iterator, basic_string> __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::iterator

Definition at line 162 of file debug/string.

## pointer

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

typedef _Base::pointer __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::pointer

Definition at line 158 of file debug/string.

## reference

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

typedef _Base::reference __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::reference

Definition at line 156 of file debug/string.

## reverse_iterator

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

typedef std::reverse_iterator<iterator> __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::reverse_iterator

Definition at line 166 of file debug/string.

## size_type

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

typedef _Base::size_type __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::size_type

Definition at line 154 of file debug/string.

## traits_type

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

typedef _Traits __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::traits_type

Definition at line 151 of file debug/string.

## value_type

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

typedef _Traits::char_type __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::value_type

Definition at line 152 of file debug/string.

## Constructor & Destructor Documentation

## basic_string() [1/11]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

__gnu_debug::basic_string< _CharT, _Traits, _Allocator >::basic_string | ( | const _Allocator & | __a | ) |

inline explicit noexcept

Definition at line 174 of file debug/string.

## basic_string() [2/11]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

__gnu_debug::basic_string< _CharT, _Traits, _Allocator >::basic_string | ( | std::initializer_list< _CharT > | __l,
|  | const _Allocator & | __a = _Allocator() )

inline

Definition at line 189 of file debug/string.

## basic_string() [3/11]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

__gnu_debug::basic_string< _CharT, _Traits, _Allocator >::basic_string | ( | const basic_string< _CharT, _Traits, _Allocator > & | __s,
|  | const _Allocator & | __a )

inline

Definition at line 194 of file debug/string.

## basic_string() [4/11]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

__gnu_debug::basic_string< _CharT, _Traits, _Allocator >::basic_string | ( | basic_string< _CharT, _Traits, _Allocator > && | __s,
|  | const _Allocator & | __a )

inline noexcept

Definition at line 197 of file debug/string.

## basic_string() [5/11]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

__gnu_debug::basic_string< _CharT, _Traits, _Allocator >::basic_string | ( | _Base && | __base | ) |

inline noexcept

Definition at line 207 of file debug/string.

## basic_string() [6/11]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

__gnu_debug::basic_string< _CharT, _Traits, _Allocator >::basic_string | ( | const _Base & | __base | ) |

inline

Definition at line 212 of file debug/string.

## basic_string() [7/11]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

__gnu_debug::basic_string< _CharT, _Traits, _Allocator >::basic_string | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos,
|  | size_type | __n = _Base::npos,
|  | const _Allocator & | __a = _Allocator() )

inline

Definition at line 217 of file debug/string.

## basic_string() [8/11]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

__gnu_debug::basic_string< _CharT, _Traits, _Allocator >::basic_string | ( | const _CharT * | __s,
|  | size_type | __n,
|  | const _Allocator & | __a = _Allocator() )

inline

Definition at line 222 of file debug/string.

## basic_string() [9/11]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

__gnu_debug::basic_string< _CharT, _Traits, _Allocator >::basic_string | ( | const _CharT * | __s,
|  | const _Allocator & | __a = _Allocator() )

inline

Definition at line 226 of file debug/string.

## basic_string() [10/11]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

__gnu_debug::basic_string< _CharT, _Traits, _Allocator >::basic_string | ( | size_type | __n,
|  | _CharT | __c,
|  | const _Allocator & | __a = _Allocator() )

inline

Definition at line 230 of file debug/string.

## basic_string() [11/11]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>
template<typename _InputIterator>

__gnu_debug::basic_string< _CharT, _Traits, _Allocator >::basic_string | ( | _InputIterator | __begin,
|  | _InputIterator | __end,
|  | const _Allocator & | __a = _Allocator() )

inline

Definition at line 235 of file debug/string.

## Member Function Documentation

## __resize_and_overwrite() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>
template<typename _Operation>

void std::basic_string< _CharT, _Traits, _Alloc >::__resize_and_overwrite | ( | size_type | __n,
|  | _Operation | __op )

constexpr inherited

Non-standard version of resize_and_overwrite for C++11 and above.

## __resize_and_overwrite() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>
template<typename _Operation>

void std::basic_string< _CharT, _Traits, _Alloc >::__resize_and_overwrite | ( | size_type | __n,
|  | _Operation | __op )

inherited

Non-standard version of resize_and_overwrite for C++11 and above.

## _M_base() [1/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const _Base & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::_M_base | ( |  | ) | const

inline noexcept

Definition at line 1063 of file debug/string.

## _M_base() [2/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

_Base & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::_M_base | ( |  | ) |

inline noexcept

Definition at line 1060 of file debug/string.

## _M_replace_dispatch()

template<typename _CharT, typename _Traits, typename _Alloc>
template<typename _InputIterator>

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::_M_replace_dispatch | ( | iterator | __i1,
|  | iterator | __i2,
|  | _InputIterator | __k1,
|  | _InputIterator | __k2,
|  | __false_type | )

inherited

Definition at line 3813 of file cow_string.h.

## _M_swap()

template<typename _SafeContainer, typename _Alloc, template< typename > class _SafeBase, bool _IsCxx11AllocatorAware = true>

void __gnu_debug::_Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware >::_M_swap | ( | _Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware > & | __x | ) |

inline constexpr protected noexcept inherited

Definition at line 131 of file safe_container.h.

## _S_construct()

template<typename _CharT, typename _Traits, typename _Alloc>
template<typename _InIterator>

_CharT * std::basic_string< _CharT, _Traits, _Alloc >::_S_construct | ( | _InIterator | __beg,
|  | _InIterator | __end,
|  | const _Alloc & | __a,
|  | forward_iterator_tag | )

inherited

Definition at line 3310 of file cow_string.h.

## append() [1/11]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>
template<typename _InputIterator>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::append | ( | _InputIterator | __first,
|  | _InputIterator | __last )

inline

Definition at line 487 of file debug/string.

## append() [2/11]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::append | ( | const _CharT * | __s | ) |

inline

Definition at line 469 of file debug/string.

## append() [3/11]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::append | ( | const _CharT * | __s,
|  | size_type | __n )

inline

Definition at line 460 of file debug/string.

## append() [4/11]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::append | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str | ) |

inline

Definition at line 444 of file debug/string.

## append() [5/11]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::append | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos,
|  | size_type | __n )

inline

Definition at line 452 of file debug/string.

## append() [6/11]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::append | ( | size_type | __n,
|  | _CharT | __c )

inline

Definition at line 478 of file debug/string.

## append() [7/11]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | const _CharT * | __s,
|  | size_type | __n )

inline constexpr inherited

Append a C substring.

Parameters

  __s | The C string to append.
  __n | The number of characters to append.

Returns
  Reference to this string.

Definition at line 1566 of file basic_string.h.

## append() [8/11]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) |

inline constexpr inherited

Append a string to this string.

Parameters

  __str | The string to append.

Returns
  Reference to this string.

Definition at line 1535 of file basic_string.h.

Referenced by std::basic_string< _CharT >::append(), std::basic_string< _CharT >::append(), std::basic_string< _CharT >::append(), std::basic_string< _CharT >::append(), std::__cxx11::collate< _CharT >::do_transform(), std::basic_string< _CharT >::operator+=(), std::basic_string< _CharT >::operator+=(), std::basic_string< _CharT >::operator+=(), std::operator>>(), and resize().

## append() [9/11]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos,
|  | size_type | __n = npos )

inline constexpr inherited

Append a substring.

Parameters

  __str | The string to append.
  __pos | Index of the first character of str to append.
  __n | The number of characters to append.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | if __pos is not a valid index.

This function appends __n characters from __str starting at __pos to this string. If __n is is larger than the number of available characters in __str, the remainder of __str is appended.

Definition at line 1553 of file basic_string.h.

## append() [10/11]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | initializer_list< _CharT > | __l | ) |

inline constexpr inherited

Append an initializer_list of characters.

Parameters

  __l | The initializer_list of characters to append.

Returns
  Reference to this string.

Definition at line 1661 of file basic_string.h.

## append() [11/11]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | size_type | __n,
|  | _CharT | __c )

inline constexpr inherited

Append multiple characters.

Parameters

  __n | The number of characters to append.
  __c | The character to use.

Returns
  Reference to this string.

Appends __n copies of __c to this string.

Definition at line 1598 of file basic_string.h.

## assign() [1/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>
template<typename _InputIterator>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::assign | ( | _InputIterator | __first,
|  | _InputIterator | __last )

inline

Definition at line 566 of file debug/string.

## assign() [2/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::assign | ( | basic_string< _CharT, _Traits, _Allocator > && | __x | ) |

inline noexcept

Definition at line 521 of file debug/string.

## assign() [3/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::assign | ( | const _CharT * | __s | ) |

inline

Definition at line 548 of file debug/string.

## assign() [4/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::assign | ( | const _CharT * | __s,
|  | size_type | __n )

inline

Definition at line 539 of file debug/string.

## assign() [5/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::assign | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos,
|  | size_type | __n )

inline

Definition at line 531 of file debug/string.

## assign() [6/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::assign | ( | const basic_string< _CharT, _Traits, _Allocator > & | __x | ) |

inline

Definition at line 512 of file debug/string.

## assign() [7/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::assign | ( | size_type | __n,
|  | _CharT | __c )

inline

Definition at line 557 of file debug/string.

## assign() [8/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::assign | ( | std::initializer_list< _CharT > | __l | ) |

inline

Definition at line 583 of file debug/string.

## assign() [9/13]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | basic_string< _CharT, _Traits, _Alloc > && | __str | ) |

inline constexpr noexcept inherited

Set value to contents of another string.

Parameters

  __str | Source string to use.

Returns
  Reference to this string.

This function sets this string to the exact contents of __str. __str is a valid, but unspecified string.

Definition at line 1786 of file basic_string.h.

## assign() [10/13]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | const _CharT * | __s,
|  | size_type | __n )

inline constexpr inherited

Set value to a C substring.

Parameters

  __s | The C string to use.
  __n | Number of characters to use.

Returns
  Reference to this string.

This function sets the value of this string to the first __n characters of __s. If __n is is larger than the number of available characters in __s, the remainder of __s is used.

Definition at line 1827 of file basic_string.h.

## assign() [11/13]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) |

inline constexpr inherited

Set value to contents of another string.

Parameters

  __str | Source string to use.

Returns
  Reference to this string.

Definition at line 1740 of file basic_string.h.

Referenced by std::basic_string< _CharT >::assign(), std::basic_string< _CharT >::assign(), std::basic_string< _CharT >::assign(), std::basic_string< _CharT >::operator=(), std::basic_string< _CharT >::operator=(), std::basic_string< _CharT >::operator=(), std::basic_string< _CharT >::operator=(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_stringbuf< char >::str(), and std::basic_stringbuf< char >::str().

## assign() [12/13]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos,
|  | size_type | __n = npos )

inline constexpr inherited

Set value to a substring of a string.

Parameters

  __str | The string to use.
  __pos | Index of the first character of str.
  __n | Number of characters to use.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | if pos is not a valid index.

This function sets this string to the substring of __str consisting of __n characters at __pos. If __n is is larger than the number of available characters in __str, the remainder of __str is used.

Definition at line 1810 of file basic_string.h.

## assign() [13/13]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | size_type | __n,
|  | _CharT | __c )

inline constexpr inherited

Set value to multiple characters.

Parameters

  __n | Length of the resulting string.
  __c | The character to use.

Returns
  Reference to this string.

This function sets the value of this string to __n copies of character __c.

Definition at line 1862 of file basic_string.h.

## at() [1/6]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

reference std::basic_string< _CharT, _Traits, _Allocator >::at | ( | size_type | __n | ) |

inline nodiscard constexpr

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read/write reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails.

Definition at line 1409 of file basic_string.h.

## at() [2/6]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

reference std::basic_string< _CharT, _Traits, _Allocator >::at | ( | size_type | __n | ) |

inline

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read/write reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails. Success results in unsharing the string.

Definition at line 1192 of file cow_string.h.

## at() [3/6]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_reference std::basic_string< _CharT, _Traits, _Allocator >::at | ( | size_type | __n | ) | const

inline nodiscard constexpr

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read-only (const) reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails.

Definition at line 1387 of file basic_string.h.

## at() [4/6]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_reference std::basic_string< _CharT, _Traits, _Allocator >::at | ( | size_type | __n | ) | const

inline

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read-only (const) reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails.

Definition at line 1170 of file cow_string.h.

## at() [5/6]

template<typename _CharT, typename _Traits, typename _Alloc>

reference std::basic_string< _CharT, _Traits, _Alloc >::at | ( | size_type | __n | ) |

inline nodiscard constexpr inherited

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read/write reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails.

Definition at line 1409 of file basic_string.h.

## at() [6/6]

template<typename _CharT, typename _Traits, typename _Alloc>

const_reference std::basic_string< _CharT, _Traits, _Alloc >::at | ( | size_type | __n | ) | const

inline nodiscard constexpr inherited

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read-only (const) reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails.

Definition at line 1387 of file basic_string.h.

## back() [1/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_reference std::basic_string< _CharT, _Traits, _Allocator >::back | ( |  | ) | const

inline nodiscard constexpr noexcept

Returns a read-only (constant) reference to the data at the last element of the string.

Definition at line 1462 of file basic_string.h.

## back() [2/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

reference std::basic_string< _CharT, _Traits, _Allocator >::back | ( |  | ) |

inline nodiscard constexpr noexcept

Returns a read/write reference to the data at the last element of the string.

Definition at line 1450 of file basic_string.h.

## begin() [1/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::begin | ( |  | ) |

inline

Definition at line 278 of file debug/string.

## begin() [2/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::begin | ( |  | ) | const

inline noexcept

Definition at line 282 of file debug/string.

## c_str()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const _CharT * __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::c_str | ( |  | ) | const

inline noexcept

Definition at line 891 of file debug/string.

## capacity()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::capacity | ( |  | ) | const

inline nodiscard constexpr noexcept

Returns the total number of characters that the string can hold before needing to allocate more memory.

Definition at line 1277 of file basic_string.h.

## cbegin()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::cbegin | ( |  | ) | const

inline noexcept

Definition at line 311 of file debug/string.

## cend()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::cend | ( |  | ) | const

inline noexcept

Definition at line 315 of file debug/string.

## clear()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

void __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::clear | ( |  | ) |

inline

Definition at line 364 of file debug/string.

## compare() [1/15]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

int __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::compare | ( | const _CharT * | __s | ) | const

inline constexpr noexcept

Definition at line 1032 of file debug/string.

## compare() [2/15]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

int std::basic_string< _CharT, _Traits, _Allocator >::compare | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str | ) | const

inline nodiscard constexpr

Compare to a string.

Parameters

  __str | String to compare against.

Returns
  Integer < 0, 0, or > 0.

Returns an integer < 0 if this string is ordered before __str, 0 if their values are equivalent, or > 0 if this string is ordered after __str. Determines the effective length rlen of the strings to compare as the smallest of size() and str.size(). The function then compares the two strings by calling traits::compare(data(), str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 3461 of file basic_string.h.

## compare() [3/15]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

int std::basic_string< _CharT, _Traits, _Allocator >::compare | ( | size_type | __pos,
|  | size_type | __n,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str ) const

inline nodiscard constexpr

Compare substring to a string.

Parameters

  __pos | Index of first character of substring.
  __n | Number of characters in substring.
  __str | String to compare against.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n characters starting at __pos. Returns an integer < 0 if the substring is ordered before __str, 0 if their values are equivalent, or > 0 if the substring is ordered after __str. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and __str.size(). The function then compares the two strings by calling traits::compare(substring.data(),str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 3556 of file basic_string.h.

## compare() [4/15]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

int std::basic_string< _CharT, _Traits, _Allocator >::compare | ( | size_type | __pos,
|  | size_type | __n,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str ) const

inline

Compare substring to a string.

Parameters

  __pos | Index of first character of substring.
  __n | Number of characters in substring.
  __str | String to compare against.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n characters starting at __pos. Returns an integer < 0 if the substring is ordered before __str, 0 if their values are equivalent, or > 0 if the substring is ordered after __str. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and __str.size(). The function then compares the two strings by calling traits::compare(substring.data(),str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 3028 of file cow_string.h.

## compare() [5/15]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

int std::basic_string< _CharT, _Traits, _Allocator >::compare | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s ) const

inline nodiscard constexpr

Compare substring to a C string.

Parameters

  __pos | Index of first character of substring.
  __n1 | Number of characters in substring.
  __s | C string to compare against.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n1 characters starting at pos. Returns an integer < 0 if the substring is ordered before __s, 0 if their values are equivalent, or > 0 if the substring is ordered after __s. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and the length of a string constructed from __s. The function then compares the two string by calling traits::compare(substring.data(),__s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 3659 of file basic_string.h.

## compare() [6/15]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

int std::basic_string< _CharT, _Traits, _Allocator >::compare | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s,
|  | size_type | __n2 ) const

inline nodiscard constexpr

Compare substring against a character array.

Parameters

  __pos | Index of first character of substring.
  __n1 | Number of characters in substring.
  __s | character array to compare against.
  __n2 | Number of characters of s.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n1 characters starting at __pos. Form a string from the first __n2 characters of __s. Returns an integer < 0 if this substring is ordered before the string from __s, 0 if their values are equivalent, or > 0 if this substring is ordered after the string from __s. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and __n2. The function then compares the two strings by calling traits::compare(substring.data(),s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

NB: s must have at least n2 characters, '\0' has no special meaning.

Definition at line 3698 of file basic_string.h.

## compare() [7/15]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

int std::basic_string< _CharT, _Traits, _Allocator >::compare | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s,
|  | size_type | __n2 ) const

inline

Compare substring against a character array.

Parameters

  __pos | Index of first character of substring.
  __n1 | Number of characters in substring.
  __s | character array to compare against.
  __n2 | Number of characters of s.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n1 characters starting at __pos. Form a string from the first __n2 characters of __s. Returns an integer < 0 if this substring is ordered before the string from __s, 0 if their values are equivalent, or > 0 if this substring is ordered after the string from __s. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and __n2. The function then compares the two strings by calling traits::compare(substring.data(),s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

NB: s must have at least n2 characters, '\0' has no special meaning.

Definition at line 3166 of file cow_string.h.

## compare() [8/15]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

int __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::compare | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const _CharT * | __s ) const

inline constexpr

Definition at line 1042 of file debug/string.

## compare() [9/15]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

int __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::compare | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const _CharT * | __s,
|  | size_type | __n2 ) const

inline constexpr

Definition at line 1052 of file debug/string.

## compare() [10/15]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

int std::basic_string< _CharT, _Traits, _Allocator >::compare | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 = npos ) const

inline nodiscard constexpr

Compare substring to a substring.

Parameters

  __pos1 | Index of first character of substring.
  __n1 | Number of characters in substring.
  __str | String to compare against.
  __pos2 | Index of first character of substring of str.
  __n2 | Number of characters in substring of str.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n1 characters starting at __pos1. Form the substring of __str from the __n2 characters starting at __pos2. Returns an integer < 0 if this substring is ordered before the substring of __str, 0 if their values are equivalent, or > 0 if this substring is ordered after the substring of __str. Determines the effective length rlen of the strings to compare as the smallest of the lengths of the substrings. The function then compares the two strings by calling traits::compare(substring.data(),str.substr(pos2,n2).data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 3593 of file basic_string.h.

## compare() [11/15]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

int std::basic_string< _CharT, _Traits, _Allocator >::compare | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 = npos ) const

inline

Compare substring to a substring.

Parameters

  __pos1 | Index of first character of substring.
  __n1 | Number of characters in substring.
  __str | String to compare against.
  __pos2 | Index of first character of substring of str.
  __n2 | Number of characters in substring of str.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n1 characters starting at __pos1. Form the substring of __str from the __n2 characters starting at __pos2. Returns an integer < 0 if this substring is ordered before the substring of __str, 0 if their values are equivalent, or > 0 if this substring is ordered after the substring of __str. Determines the effective length rlen of the strings to compare as the smallest of the lengths of the substrings. The function then compares the two strings by calling traits::compare(substring.data(),str.substr(pos2,n2).data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 3064 of file cow_string.h.

## compare() [12/15]

template<typename _CharT, typename _Traits, typename _Alloc>

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | size_type | __pos,
|  | size_type | __n,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str ) const

inline nodiscard constexpr inherited

Compare substring to a string.

Parameters

  __pos | Index of first character of substring.
  __n | Number of characters in substring.
  __str | String to compare against.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n characters starting at __pos. Returns an integer < 0 if the substring is ordered before __str, 0 if their values are equivalent, or > 0 if the substring is ordered after __str. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and __str.size(). The function then compares the two strings by calling traits::compare(substring.data(),str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 3556 of file basic_string.h.

## compare() [13/15]

template<typename _CharT, typename _Traits, typename _Alloc>

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s ) const

inline nodiscard constexpr inherited

Compare substring to a C string.

Parameters

  __pos | Index of first character of substring.
  __n1 | Number of characters in substring.
  __s | C string to compare against.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n1 characters starting at pos. Returns an integer < 0 if the substring is ordered before __s, 0 if their values are equivalent, or > 0 if the substring is ordered after __s. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and the length of a string constructed from __s. The function then compares the two string by calling traits::compare(substring.data(),__s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 3659 of file basic_string.h.

## compare() [14/15]

template<typename _CharT, typename _Traits, typename _Alloc>

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s,
|  | size_type | __n2 ) const

inline nodiscard constexpr inherited

Compare substring against a character array.

Parameters

  __pos | Index of first character of substring.
  __n1 | Number of characters in substring.
  __s | character array to compare against.
  __n2 | Number of characters of s.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n1 characters starting at __pos. Form a string from the first __n2 characters of __s. Returns an integer < 0 if this substring is ordered before the string from __s, 0 if their values are equivalent, or > 0 if this substring is ordered after the string from __s. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and __n2. The function then compares the two strings by calling traits::compare(substring.data(),s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

NB: s must have at least n2 characters, '\0' has no special meaning.

Definition at line 3698 of file basic_string.h.

## compare() [15/15]

template<typename _CharT, typename _Traits, typename _Alloc>

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 = npos ) const

inline nodiscard constexpr inherited

Compare substring to a substring.

Parameters

  __pos1 | Index of first character of substring.
  __n1 | Number of characters in substring.
  __str | String to compare against.
  __pos2 | Index of first character of substring of str.
  __n2 | Number of characters in substring of str.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n1 characters starting at __pos1. Form the substring of __str from the __n2 characters starting at __pos2. Returns an integer < 0 if this substring is ordered before the substring of __str, 0 if their values are equivalent, or > 0 if this substring is ordered after the substring of __str. Determines the effective length rlen of the strings to compare as the smallest of the lengths of the substrings. The function then compares the two strings by calling traits::compare(substring.data(),str.substr(pos2,n2).data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 3593 of file basic_string.h.

## copy() [1/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::copy | ( | _CharT * | __s,
|  | size_type | __n,
|  | size_type | __pos = 0 ) const

inline

Definition at line 875 of file debug/string.

## copy() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::copy | ( | _CharT * | __s,
|  | size_type | __n,
|  | size_type | __pos = 0 ) const

constexpr inherited

Copy substring into C string.

Parameters

  __s | C string to copy value into.
  __n | Number of characters to copy.
  __pos | Index of first character to copy.

Returns
  Number of characters actually copied

Exceptions

  std::out_of_range | If __pos > size().

Copies up to __n characters starting at __pos into the C string __s. If __pos is greater than size(), out_of_range is thrown.

Definition at line 3872 of file cow_string.h.

## crbegin()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_reverse_iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::crbegin | ( |  | ) | const

inline noexcept

Definition at line 319 of file debug/string.

## crend()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_reverse_iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::crend | ( |  | ) | const

inline noexcept

Definition at line 323 of file debug/string.

## data() [1/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const _CharT * __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::data | ( |  | ) | const

inline noexcept

Definition at line 899 of file debug/string.

## data() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

_CharT * std::basic_string< _CharT, _Traits, _Alloc >::data | ( |  | ) |

inline nodiscard constexpr noexcept inherited

Return non-const pointer to contents.

This is a pointer to the character sequence held by the string. Modifying the characters in the sequence is allowed.

Definition at line 2898 of file basic_string.h.

## empty()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

bool std::basic_string< _CharT, _Traits, _Allocator >::empty | ( |  | ) | const

inline nodiscard constexpr noexcept

Returns true if the string is empty. Equivalent to `*this == ""`.

Definition at line 1331 of file basic_string.h.

## end() [1/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::end | ( |  | ) |

inline

Definition at line 286 of file debug/string.

## end() [2/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::end | ( |  | ) | const

inline noexcept

Definition at line 290 of file debug/string.

## ends_with() [1/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::ends_with | ( | _CharT | __x | ) | const

inline nodiscard constexpr noexcept inherited

Definition at line 3734 of file basic_string.h.

## ends_with() [2/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::ends_with | ( | _CharT | __x | ) | const

inline noexcept inherited

Definition at line 3198 of file cow_string.h.

## ends_with() [3/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::ends_with | ( | basic_string_view< _CharT, _Traits > | __x | ) | const

inline nodiscard constexpr noexcept inherited

Definition at line 3729 of file basic_string.h.

## ends_with() [4/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::ends_with | ( | basic_string_view< _CharT, _Traits > | __x | ) | const

inline noexcept inherited

Definition at line 3194 of file cow_string.h.

## ends_with() [5/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::ends_with | ( | const _CharT * | __x | ) | const

inline nodiscard constexpr noexcept inherited

Definition at line 3739 of file basic_string.h.

## ends_with() [6/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::ends_with | ( | const _CharT * | __x | ) | const

inline noexcept inherited

Definition at line 3203 of file cow_string.h.

## erase() [1/8]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::erase | ( | __const_iterator | __first,
|  | __const_iterator | __last )

inline

Definition at line 734 of file debug/string.

## erase() [2/8]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::erase | ( | __const_iterator | __position | ) |

inline

Definition at line 725 of file debug/string.

## erase() [3/8]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::erase | ( | size_type | __pos = 0,
|  | size_type | __n = _Base::npos )

inline

Definition at line 717 of file debug/string.

## erase() [4/8]

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::erase | ( | __const_iterator | __first,
|  | __const_iterator | __last )

inline constexpr inherited

Remove a range of characters.

Parameters

  __first | Iterator referencing the first character to remove.
  __last | Iterator referencing the end of the range.

Returns
  Iterator referencing location of first after removal.

Removes the characters in the range [first,last) from this string. The value of the string doesn't change if an error is thrown.

Definition at line 2363 of file basic_string.h.

## erase() [5/8]

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::erase | ( | __const_iterator | __position | ) |

inline constexpr inherited

Remove one character.

Parameters

  __position | Iterator referencing the character to remove.

Returns
  iterator referencing same location after removal.

Removes the character at __position from this string. The value of the string doesn't change if an error is thrown.

Definition at line 2343 of file basic_string.h.

## erase() [6/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::iterator std::basic_string< _CharT, _Traits, _Alloc >::erase | ( | iterator | __first,
|  | iterator | __last )

inherited

Remove a range of characters.

Parameters

  __first | Iterator referencing the first character to remove.
  __last | Iterator referencing the end of the range.

Returns
  Iterator referencing location of first after removal.

Removes the characters in the range [first,last) from this string. The value of the string doesn't change if an error is thrown.

Definition at line 3536 of file cow_string.h.

## erase() [7/8]

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::erase | ( | iterator | __position | ) |

inline inherited

Remove one character.

Parameters

  __position | Iterator referencing the character to remove.

Returns
  iterator referencing same location after removal.

Removes the character at __position from this string. The value of the string doesn't change if an error is thrown.

Definition at line 1874 of file cow_string.h.

## erase() [8/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::erase | ( | size_type | __pos = 0,
|  | size_type | __n = npos )

inline constexpr inherited

Remove characters.

Parameters

  __pos | Index of first character to remove (default 0).
  __n | Number of characters to remove (default remainder).

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If pos is beyond the end of this string.

Removes __n characters from this string starting at __pos. The length of the string is reduced by __n. If there are < __n characters to remove, the remainder of the string is truncated. If __p is beyond end of string, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2323 of file basic_string.h.

Referenced by std::getline(), std::operator>>(), std::basic_string< _CharT >::pop_back(), and resize().

## find() [1/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find | ( | _CharT | __c,
|  | size_type | __pos = 0 ) const

nodiscard constexpr noexcept

Find position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for __c within this string. If found, returns the index where it was found. If not found, returns npos.

## find() [2/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find | ( | _CharT | __c,
|  | size_type | __pos = 0 ) const

noexcept

Find position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for __c within this string. If found, returns the index where it was found. If not found, returns npos.

## find() [3/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::find | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

inline constexpr noexcept

Definition at line 912 of file debug/string.

## find() [4/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

nodiscard constexpr noexcept

Find position of a C substring.

Parameters

  __s | C string to locate.
  __pos | Index of character to search from.
  __n | Number of characters from s to search for.

Returns
  Index of start of first occurrence.

Starting from __pos, searches forward for the first __n characters in __s within this string. If found, returns the index where it begins. If not found, returns npos.

## find() [5/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

noexcept

Find position of a C substring.

Parameters

  __s | C string to locate.
  __pos | Index of character to search from.
  __n | Number of characters from s to search for.

Returns
  Index of start of first occurrence.

Starting from __pos, searches forward for the first __n characters in __s within this string. If found, returns the index where it begins. If not found, returns npos.

## find() [6/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::find | ( | const _CharT * | __s,
|  | size_type | __pos = 0 ) const

inline constexpr noexcept

Definition at line 921 of file debug/string.

## find() [7/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find | ( | const _CharT * | __s,
|  | size_type | __pos = 0 ) const

inline nodiscard constexpr noexcept

Find position of a C string.

Parameters

  __s | C string to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of start of first occurrence.

Starting from __pos, searches forward for the value of __s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 2973 of file basic_string.h.

## find() [8/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = 0 ) const

inline nodiscard constexpr noexcept

Find position of a string.

Parameters

  __str | String to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of start of first occurrence.

Starting from __pos, searches forward for value of __str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 2939 of file basic_string.h.

## find() [9/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = 0 ) const

inline noexcept

Find position of a string.

Parameters

  __str | String to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of start of first occurrence.

Starting from __pos, searches forward for value of __str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 2445 of file cow_string.h.

## find() [10/13]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find | ( | _CharT | __c,
|  | size_type | __pos = 0 ) const

nodiscard constexpr noexcept inherited

Find position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for __c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 694 of file basic_string.tcc.

References npos, and std::size().

## find() [11/13]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

nodiscard constexpr noexcept inherited

Find position of a C substring.

Parameters

  __s | C string to locate.
  __pos | Index of character to search from.
  __n | Number of characters from s to search for.

Returns
  Index of start of first occurrence.

Starting from __pos, searches forward for the first __n characters in __s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 657 of file basic_string.tcc.

References std::data(), npos, and std::size().

Referenced by std::basic_string< _CharT >::find(), std::basic_string< _CharT >::find(), std::basic_string< _CharT >::find(), and std::basic_string< _CharT >::find_first_of().

## find() [12/13]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find | ( | const _CharT * | __s,
|  | size_type | __pos = 0 ) const

inline nodiscard constexpr noexcept inherited

Find position of a C string.

Parameters

  __s | C string to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of start of first occurrence.

Starting from __pos, searches forward for the value of __s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 2973 of file basic_string.h.

## find() [13/13]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = 0 ) const

inline nodiscard constexpr noexcept inherited

Find position of a string.

Parameters

  __str | String to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of start of first occurrence.

Starting from __pos, searches forward for value of __str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 2939 of file basic_string.h.

## find_first_not_of() [1/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_first_not_of | ( | _CharT | __c,
|  | size_type | __pos = 0 ) const

nodiscard constexpr noexcept

Find position of a different character.

Parameters

  __c | Character to avoid.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character other than __c within this string. If found, returns the index where it was found. If not found, returns npos.

## find_first_not_of() [2/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_first_not_of | ( | _CharT | __c,
|  | size_type | __pos = 0 ) const

noexcept

Find position of a different character.

Parameters

  __c | Character to avoid.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character other than __c within this string. If found, returns the index where it was found. If not found, returns npos.

## find_first_not_of() [3/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::find_first_not_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

inline constexpr noexcept

Definition at line 988 of file debug/string.

## find_first_not_of() [4/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_first_not_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

nodiscard constexpr noexcept

Find position of a character not in C substring.

Parameters

  __s | C string containing characters to avoid.
  __pos | Index of character to search from.
  __n | Number of characters from __s to consider.

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character not contained in the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

## find_first_not_of() [5/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_first_not_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

noexcept

Find position of a character not in C substring.

Parameters

  __s | C string containing characters to avoid.
  __pos | Index of character to search from.
  __n | Number of characters from __s to consider.

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character not contained in the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

## find_first_not_of() [6/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::find_first_not_of | ( | const _CharT * | __s,
|  | size_type | __pos = 0 ) const

inline constexpr noexcept

Definition at line 997 of file debug/string.

## find_first_not_of() [7/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_first_not_of | ( | const _CharT * | __s,
|  | size_type | __pos = 0 ) const

inline nodiscard constexpr noexcept

Find position of a character not in C string.

Parameters

  __s | C string containing characters to avoid.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character not contained in __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3318 of file basic_string.h.

## find_first_not_of() [8/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_first_not_of | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = 0 ) const

inline nodiscard constexpr noexcept

Find position of a character not in string.

Parameters

  __str | String containing characters to avoid.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character not contained in __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3266 of file basic_string.h.

## find_first_not_of() [9/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_first_not_of | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = 0 ) const

inline noexcept

Find position of a character not in string.

Parameters

  __str | String containing characters to avoid.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character not contained in __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2753 of file cow_string.h.

## find_first_not_of() [10/13]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_not_of | ( | _CharT | __c,
|  | size_type | __pos = 0 ) const

nodiscard constexpr noexcept inherited

Find position of a different character.

Parameters

  __c | Character to avoid.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character other than __c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 808 of file basic_string.tcc.

References npos, and std::size().

## find_first_not_of() [11/13]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_not_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

nodiscard constexpr noexcept inherited

Find position of a character not in C substring.

Parameters

  __s | C string containing characters to avoid.
  __pos | Index of character to search from.
  __n | Number of characters from __s to consider.

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character not contained in the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 794 of file basic_string.tcc.

References npos, and std::size().

## find_first_not_of() [12/13]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_not_of | ( | const _CharT * | __s,
|  | size_type | __pos = 0 ) const

inline nodiscard constexpr noexcept inherited

Find position of a character not in C string.

Parameters

  __s | C string containing characters to avoid.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character not contained in __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3318 of file basic_string.h.

## find_first_not_of() [13/13]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_not_of | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = 0 ) const

inline nodiscard constexpr noexcept inherited

Find position of a character not in string.

Parameters

  __str | String containing characters to avoid.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character not contained in __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3266 of file basic_string.h.

Referenced by std::basic_string< _CharT >::find_first_not_of(), std::basic_string< _CharT >::find_first_not_of(), and std::basic_string< _CharT >::find_first_not_of().

## find_first_of() [1/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_first_of | ( | _CharT | __c,
|  | size_type | __pos = 0 ) const

inline nodiscard constexpr noexcept

Find position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for the character __c within this string. If found, returns the index where it was found. If not found, returns npos.

Note: equivalent to find(__c, __pos).

Definition at line 3162 of file basic_string.h.

## find_first_of() [2/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_first_of | ( | _CharT | __c,
|  | size_type | __pos = 0 ) const

inline noexcept

Find position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for the character __c within this string. If found, returns the index where it was found. If not found, returns npos.

Note: equivalent to find(__c, __pos).

Definition at line 2637 of file cow_string.h.

## find_first_of() [3/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::find_first_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

inline constexpr noexcept

Definition at line 949 of file debug/string.

## find_first_of() [4/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_first_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

nodiscard constexpr noexcept

Find position of a character of C substring.

Parameters

  __s | String containing characters to locate.
  __pos | Index of character to search from.
  __n | Number of characters from s to search for.

Returns
  Index of first occurrence.

Starting from __pos, searches forward for one of the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

## find_first_of() [5/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_first_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

noexcept

Find position of a character of C substring.

Parameters

  __s | String containing characters to locate.
  __pos | Index of character to search from.
  __n | Number of characters from s to search for.

Returns
  Index of first occurrence.

Starting from __pos, searches forward for one of the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

## find_first_of() [6/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::find_first_of | ( | const _CharT * | __s,
|  | size_type | __pos = 0 ) const

inline constexpr noexcept

Definition at line 958 of file debug/string.

## find_first_of() [7/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_first_of | ( | const _CharT * | __s,
|  | size_type | __pos = 0 ) const

inline nodiscard constexpr noexcept

Find position of a character of C string.

Parameters

  __s | String containing characters to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for one of the characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3141 of file basic_string.h.

## find_first_of() [8/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_first_of | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = 0 ) const

inline nodiscard constexpr noexcept

Find position of a character of string.

Parameters

  __str | String containing characters to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for one of the characters of __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3089 of file basic_string.h.

## find_first_of() [9/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_first_of | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = 0 ) const

inline noexcept

Find position of a character of string.

Parameters

  __str | String containing characters to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for one of the characters of __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2586 of file cow_string.h.

## find_first_of() [10/13]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_of | ( | _CharT | __c,
|  | size_type | __pos = 0 ) const

inline nodiscard constexpr noexcept inherited

Find position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for the character __c within this string. If found, returns the index where it was found. If not found, returns npos.

Note: equivalent to find(__c, __pos).

Definition at line 3162 of file basic_string.h.

## find_first_of() [11/13]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

nodiscard constexpr noexcept inherited

Find position of a character of C substring.

Parameters

  __s | String containing characters to locate.
  __pos | Index of character to search from.
  __n | Number of characters from s to search for.

Returns
  Index of first occurrence.

Starting from __pos, searches forward for one of the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 754 of file basic_string.tcc.

References npos, and std::size().

## find_first_of() [12/13]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_of | ( | const _CharT * | __s,
|  | size_type | __pos = 0 ) const

inline nodiscard constexpr noexcept inherited

Find position of a character of C string.

Parameters

  __s | String containing characters to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for one of the characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3141 of file basic_string.h.

## find_first_of() [13/13]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_of | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = 0 ) const

inline nodiscard constexpr noexcept inherited

Find position of a character of string.

Parameters

  __str | String containing characters to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for one of the characters of __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3089 of file basic_string.h.

Referenced by std::basic_string< _CharT >::find_first_of(), and std::basic_string< _CharT >::find_first_of().

## find_last_not_of() [1/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_last_not_of | ( | _CharT | __c,
|  | size_type | __pos = npos ) const

nodiscard constexpr noexcept

Find last position of a different character.

Parameters

  __c | Character to avoid.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character other than __c within this string. If found, returns the index where it was found. If not found, returns npos.

## find_last_not_of() [2/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_last_not_of | ( | _CharT | __c,
|  | size_type | __pos = npos ) const

noexcept

Find last position of a different character.

Parameters

  __c | Character to avoid.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character other than __c within this string. If found, returns the index where it was found. If not found, returns npos.

## find_last_not_of() [3/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::find_last_not_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

inline constexpr noexcept

Definition at line 1008 of file debug/string.

## find_last_not_of() [4/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_last_not_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

nodiscard constexpr noexcept

Find last position of a character not in C substring.

Parameters

  __s | C string containing characters to avoid.
  __pos | Index of character to search back from.
  __n | Number of characters from s to consider.

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character not contained in the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

## find_last_not_of() [5/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_last_not_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

noexcept

Find last position of a character not in C substring.

Parameters

  __s | C string containing characters to avoid.
  __pos | Index of character to search back from.
  __n | Number of characters from s to consider.

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character not contained in the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

## find_last_not_of() [6/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::find_last_not_of | ( | const _CharT * | __s,
|  | size_type | __pos = _Base::npos ) const

inline constexpr noexcept

Definition at line 1017 of file debug/string.

## find_last_not_of() [7/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_last_not_of | ( | const _CharT * | __s,
|  | size_type | __pos = npos ) const

inline nodiscard constexpr noexcept

Find last position of a character not in C string.

Parameters

  __s | C string containing characters to avoid.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character not contained in __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3405 of file basic_string.h.

## find_last_not_of() [8/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_last_not_of | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = npos ) const

inline nodiscard constexpr noexcept

Find last position of a character not in string.

Parameters

  __str | String containing characters to avoid.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character not contained in __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3353 of file basic_string.h.

## find_last_not_of() [9/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_last_not_of | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = npos ) const

inline noexcept

Find last position of a character not in string.

Parameters

  __str | String containing characters to avoid.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character not contained in __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2835 of file cow_string.h.

## find_last_not_of() [10/13]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_not_of | ( | _CharT | __c,
|  | size_type | __pos = npos ) const

nodiscard constexpr noexcept inherited

Find last position of a different character.

Parameters

  __c | Character to avoid.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character other than __c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 843 of file basic_string.tcc.

References npos, and std::size().

## find_last_not_of() [11/13]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_not_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

nodiscard constexpr noexcept inherited

Find last position of a character not in C substring.

Parameters

  __s | C string containing characters to avoid.
  __pos | Index of character to search back from.
  __n | Number of characters from s to consider.

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character not contained in the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 820 of file basic_string.tcc.

References npos, and std::size().

## find_last_not_of() [12/13]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_not_of | ( | const _CharT * | __s,
|  | size_type | __pos = npos ) const

inline nodiscard constexpr noexcept inherited

Find last position of a character not in C string.

Parameters

  __s | C string containing characters to avoid.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character not contained in __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3405 of file basic_string.h.

## find_last_not_of() [13/13]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_not_of | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = npos ) const

inline nodiscard constexpr noexcept inherited

Find last position of a character not in string.

Parameters

  __str | String containing characters to avoid.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character not contained in __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3353 of file basic_string.h.

Referenced by std::basic_string< _CharT >::find_last_not_of(), std::basic_string< _CharT >::find_last_not_of(), and std::basic_string< _CharT >::find_last_not_of().

## find_last_of() [1/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_last_of | ( | _CharT | __c,
|  | size_type | __pos = npos ) const

inline nodiscard constexpr noexcept

Find last position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for __c within this string. If found, returns the index where it was found. If not found, returns npos.

Note: equivalent to rfind(__c, __pos).

Definition at line 3251 of file basic_string.h.

## find_last_of() [2/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_last_of | ( | _CharT | __c,
|  | size_type | __pos = npos ) const

inline noexcept

Find last position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for __c within this string. If found, returns the index where it was found. If not found, returns npos.

Note: equivalent to rfind(__c, __pos).

Definition at line 2721 of file cow_string.h.

## find_last_of() [3/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::find_last_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

inline constexpr noexcept

Definition at line 968 of file debug/string.

## find_last_of() [4/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_last_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

nodiscard constexpr noexcept

Find last position of a character of C substring.

Parameters

  __s | C string containing characters to locate.
  __pos | Index of character to search back from.
  __n | Number of characters from s to search for.

Returns
  Index of last occurrence.

Starting from __pos, searches backward for one of the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

## find_last_of() [5/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_last_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

noexcept

Find last position of a character of C substring.

Parameters

  __s | C string containing characters to locate.
  __pos | Index of character to search back from.
  __n | Number of characters from s to search for.

Returns
  Index of last occurrence.

Starting from __pos, searches backward for one of the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

## find_last_of() [6/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::find_last_of | ( | const _CharT * | __s,
|  | size_type | __pos = _Base::npos ) const

inline constexpr noexcept

Definition at line 977 of file debug/string.

## find_last_of() [7/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_last_of | ( | const _CharT * | __s,
|  | size_type | __pos = npos ) const

inline nodiscard constexpr noexcept

Find last position of a character of C string.

Parameters

  __s | C string containing characters to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for one of the characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3230 of file basic_string.h.

## find_last_of() [8/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_last_of | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = npos ) const

inline nodiscard constexpr noexcept

Find last position of a character of string.

Parameters

  __str | String containing characters to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for one of the characters of __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3178 of file basic_string.h.

## find_last_of() [9/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_last_of | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = npos ) const

inline noexcept

Find last position of a character of string.

Parameters

  __str | String containing characters to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for one of the characters of __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2670 of file cow_string.h.

## find_last_of() [10/13]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_of | ( | _CharT | __c,
|  | size_type | __pos = npos ) const

inline nodiscard constexpr noexcept inherited

Find last position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for __c within this string. If found, returns the index where it was found. If not found, returns npos.

Note: equivalent to rfind(__c, __pos).

Definition at line 3251 of file basic_string.h.

## find_last_of() [11/13]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

nodiscard constexpr noexcept inherited

Find last position of a character of C substring.

Parameters

  __s | C string containing characters to locate.
  __pos | Index of character to search back from.
  __n | Number of characters from s to search for.

Returns
  Index of last occurrence.

Starting from __pos, searches backward for one of the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 771 of file basic_string.tcc.

References npos, and std::size().

## find_last_of() [12/13]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_of | ( | const _CharT * | __s,
|  | size_type | __pos = npos ) const

inline nodiscard constexpr noexcept inherited

Find last position of a character of C string.

Parameters

  __s | C string containing characters to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for one of the characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3230 of file basic_string.h.

## find_last_of() [13/13]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_of | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = npos ) const

inline nodiscard constexpr noexcept inherited

Find last position of a character of string.

Parameters

  __str | String containing characters to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for one of the characters of __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3178 of file basic_string.h.

Referenced by std::basic_string< _CharT >::find_last_of(), and std::basic_string< _CharT >::find_last_of().

## front() [1/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_reference std::basic_string< _CharT, _Traits, _Allocator >::front | ( |  | ) | const

inline nodiscard constexpr noexcept

Returns a read-only (constant) reference to the data at the first element of the string.

Definition at line 1438 of file basic_string.h.

## front() [2/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

reference std::basic_string< _CharT, _Traits, _Allocator >::front | ( |  | ) |

inline nodiscard constexpr noexcept

Returns a read/write reference to the data at the first element of the string.

Definition at line 1426 of file basic_string.h.

## get_allocator()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

allocator_type std::basic_string< _CharT, _Traits, _Allocator >::get_allocator | ( |  | ) | const

inline nodiscard constexpr noexcept

Return copy of allocator used to construct this string.

Definition at line 2907 of file basic_string.h.

## insert() [1/22]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::insert | ( | __const_iterator | __p,
|  | _CharT | __c )

inline

Definition at line 635 of file debug/string.

## insert() [2/22]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>
template<typename _InputIterator>

iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::insert | ( | __const_iterator | __p,
|  | _InputIterator | __first,
|  | _InputIterator | __last )

inline

Definition at line 670 of file debug/string.

## insert() [3/22]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::insert | ( | const_iterator | __p,
|  | size_type | __n,
|  | _CharT | __c )

inline

Definition at line 645 of file debug/string.

## insert() [4/22]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::insert | ( | const_iterator | __p,
|  | std::initializer_list< _CharT > | __l )

inline

Definition at line 701 of file debug/string.

## insert() [5/22]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::insert | ( | size_type | __pos,
|  | const _CharT * | __s )

inline

Definition at line 618 of file debug/string.

## insert() [6/22]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::insert | ( | size_type | __pos,
|  | const _CharT * | __s,
|  | size_type | __n )

inline

Definition at line 609 of file debug/string.

## insert() [7/22]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::insert | ( | size_type | __pos,
|  | size_type | __n,
|  | _CharT | __c )

inline

Definition at line 627 of file debug/string.

## insert() [8/22]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::insert | ( | size_type | __pos1,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str )

inline

Definition at line 592 of file debug/string.

## insert() [9/22]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::insert | ( | size_type | __pos1,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos2,
|  | size_type | __n )

inline

Definition at line 600 of file debug/string.

## insert() [10/22]

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | __const_iterator | __p,
|  | _CharT | __c )

inline constexpr inherited

Insert one character.

Parameters

  __p | Iterator referencing position in string to insert at.
  __c | The character to insert.

Returns
  Iterator referencing newly inserted char.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts character __c at position referenced by __p. If adding character causes the length to exceed max_size(), length_error is thrown. If __p is beyond end of string, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2260 of file basic_string.h.

## insert() [11/22]

template<typename _CharT, typename _Traits, typename _Alloc>
template<class _InputIterator, typename = std::_RequireInputIter<_InputIterator>>

iterator std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | const_iterator | __p,
|  | _InputIterator | __beg,
|  | _InputIterator | __end )

inline constexpr inherited

Insert a range of characters.

Parameters

  __p | Const_iterator referencing location in string to insert at.
  __beg | Start of range.
  __end | End of range.

Returns
  Iterator referencing the first inserted char.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts characters in range [beg,end). If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2054 of file basic_string.h.

## insert() [12/22]

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | const_iterator | __p,
|  | initializer_list< _CharT > | __l )

inline constexpr inherited

Insert an initializer_list of characters.

Parameters

  __p | Iterator referencing location in string to insert at.
  __l | The initializer_list of characters to insert.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Definition at line 2120 of file basic_string.h.

## insert() [13/22]

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | const_iterator | __p,
|  | size_type | __n,
|  | _CharT | __c )

inline constexpr inherited

Insert multiple characters.

Parameters

  __p | Const_iterator referencing location in string to insert at.
  __n | Number of characters to insert
  __c | The character to insert.

Returns
  Iterator referencing the first inserted char.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts __n copies of character __c starting at the position referenced by iterator __p. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2009 of file basic_string.h.

Referenced by std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), and std::basic_string< _CharT >::insert().

## insert() [14/22]

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | iterator | __p,
|  | _CharT | __c )

inline inherited

Insert one character.

Parameters

  __p | Iterator referencing position in string to insert at.
  __c | The character to insert.

Returns
  Iterator referencing newly inserted char.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts character __c at position referenced by __p. If adding character causes the length to exceed max_size(), length_error is thrown. If __p is beyond end of string, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1798 of file cow_string.h.

## insert() [15/22]

template<typename _CharT, typename _Traits, typename _Alloc>
template<class _InputIterator>

void std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | iterator | __p,
|  | _InputIterator | __beg,
|  | _InputIterator | __end )

inline inherited

Insert a range of characters.

Parameters

  __p | Iterator referencing location in string to insert at.
  __beg | Start of range.
  __end | End of range.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts characters in range [__beg,__end). If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1636 of file cow_string.h.

## insert() [16/22]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | iterator | __p,
|  | initializer_list< _CharT > | __l )

inline inherited

Insert an initializer_list of characters.

Parameters

  __p | Iterator referencing location in string to insert at.
  __l | The initializer_list of characters to insert.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Definition at line 1674 of file cow_string.h.

## insert() [17/22]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | iterator | __p,
|  | size_type | __n,
|  | _CharT | __c )

inline inherited

Insert multiple characters.

Parameters

  __p | Iterator referencing location in string to insert at.
  __n | Number of characters to insert
  __c | The character to insert.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts __n copies of character __c starting at the position referenced by iterator __p. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1619 of file cow_string.h.

## insert() [18/22]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos,
|  | const _CharT * | __s )

inline constexpr inherited

Insert a C string.

Parameters

  __pos | Position in string to insert at.
  __s | The C string to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.
  std::out_of_range | If pos is beyond the end of this string.

Inserts the first n characters of __s starting at __pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If __pos is beyond end(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2216 of file basic_string.h.

## insert() [19/22]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos,
|  | const _CharT * | __s,
|  | size_type | __n )

inline constexpr inherited

Insert a C substring.

Parameters

  __pos | Position in string to insert at.
  __s | The C string to insert.
  __n | The number of characters to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.
  std::out_of_range | If __pos is beyond the end of this string.

Inserts the first __n characters of __s starting at __pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If __pos is beyond end(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2196 of file basic_string.h.

## insert() [20/22]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos,
|  | size_type | __n,
|  | _CharT | __c )

inline constexpr inherited

Insert multiple characters.

Parameters

  __pos | Index in string to insert at.
  __n | Number of characters to insert
  __c | The character to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.
  std::out_of_range | If __pos is beyond the end of this string.

Inserts __n copies of character __c starting at index __pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If __pos > length(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2241 of file basic_string.h.

## insert() [21/22]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos1,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str )

inline constexpr inherited

Insert value of a string.

Parameters

  __pos1 | Position in string to insert at.
  __str | The string to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts value of __str starting at __pos1. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2148 of file basic_string.h.

## insert() [22/22]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos1,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos2,
|  | size_type | __n = npos )

inline constexpr inherited

Insert a substring.

Parameters

  __pos1 | Position in string to insert at.
  __str | The string to insert.
  __pos2 | Start of characters in str to insert.
  __n | Number of characters to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.
  std::out_of_range | If pos1 > size() or __pos2 > str.size().

Starting at pos1, insert __n character of __str beginning with __pos2. If adding characters causes the length to exceed max_size(), length_error is thrown. If __pos1 is beyond the end of this string or __pos2 is beyond the end of __str, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2172 of file basic_string.h.

## length()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::length | ( |  | ) | const

inline nodiscard constexpr noexcept

Returns the number of characters in the string, not including any null-termination.

Definition at line 1175 of file basic_string.h.

## max_size()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::max_size | ( |  | ) | const

inline nodiscard constexpr noexcept

Returns the size() of the largest possible string.

Definition at line 1181 of file basic_string.h.

## operator+=() [1/5]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator+= | ( | _CharT | __c | ) |

inline

Definition at line 426 of file debug/string.

## operator+=() [2/5]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator+= | ( | const _CharT * | __s | ) |

inline

Definition at line 417 of file debug/string.

## operator+=() [3/5]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator+= | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str | ) |

inline

Definition at line 409 of file debug/string.

## operator+=() [4/5]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator+= | ( | std::initializer_list< _CharT > | __l | ) |

inline

Definition at line 435 of file debug/string.

## operator+=() [5/5]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator+= | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) |

inline constexpr inherited

Append a string to this string.

Parameters

  __str | The string to append.

Returns
  Reference to this string.

Definition at line 1477 of file basic_string.h.

## operator=() [1/3]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator= | ( | _CharT | __c | ) |

inline

Definition at line 259 of file debug/string.

## operator=() [2/3]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator= | ( | const _CharT * | __s | ) |

inline

Definition at line 250 of file debug/string.

## operator=() [3/3]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator= | ( | std::initializer_list< _CharT > | __l | ) |

inline

Definition at line 268 of file debug/string.

## operator[]() [1/4]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

reference __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator[] | ( | size_type | __pos | ) |

inline

Definition at line 385 of file debug/string.

## operator[]() [2/4]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_reference __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator[] | ( | size_type | __pos | ) | const

inline noexcept

Definition at line 374 of file debug/string.

## operator[]() [3/4]

template<typename _CharT, typename _Traits, typename _Alloc>

reference std::basic_string< _CharT, _Traits, _Alloc >::operator[] | ( | size_type | __pos | ) |

inline nodiscard constexpr inherited

Subscript access to the data contained in the string.

Parameters

  __pos | The index of the character to access.

Returns
  Read/write reference to the character.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 1365 of file basic_string.h.

## operator[]() [4/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const_reference std::basic_string< _CharT, _Traits, _Alloc >::operator[] | ( | size_type | __pos | ) | const

inline nodiscard constexpr noexcept inherited

Subscript access to the data contained in the string.

Parameters

  __pos | The index of the character to access.

Returns
  Read-only (constant) reference to the character.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 1347 of file basic_string.h.

Referenced by std::basic_string< _CharT >::back(), std::basic_string< _CharT >::back(), std::basic_string< _CharT >::back(), std::basic_string< _CharT >::front(), std::basic_string< _CharT >::front(), and std::basic_string< _CharT >::front().

## pop_back()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

void __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::pop_back | ( |  | ) |

inline

Definition at line 747 of file debug/string.

## push_back()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

void __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::push_back | ( | _CharT | __c | ) |

inline

Definition at line 505 of file debug/string.

## rbegin() [1/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

reverse_iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::rbegin | ( |  | ) |

inline

Definition at line 294 of file debug/string.

## rbegin() [2/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_reverse_iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::rbegin | ( |  | ) | const

inline noexcept

Definition at line 298 of file debug/string.

## rend() [1/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

reverse_iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::rend | ( |  | ) |

inline

Definition at line 302 of file debug/string.

## rend() [2/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_reverse_iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::rend | ( |  | ) | const

inline noexcept

Definition at line 306 of file debug/string.

## replace() [1/36]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>
template<typename _InputIterator>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | _InputIterator | __j1,
|  | _InputIterator | __j2 )

inline

Definition at line 843 of file debug/string.

## replace() [2/36]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | const _CharT * | __s )

inline

Definition at line 821 of file debug/string.

## replace() [3/36]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | const _CharT * | __s,
|  | size_type | __n )

inline

Definition at line 810 of file debug/string.

## replace() [4/36]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str )

inline

Definition at line 800 of file debug/string.

## replace() [5/36]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | size_type | __n,
|  | _CharT | __c )

inline

Definition at line 832 of file debug/string.

## replace() [6/36]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | std::initializer_list< _CharT > | __l )

inline

Definition at line 864 of file debug/string.

## replace() [7/36]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s )

inline

Definition at line 783 of file debug/string.

## replace() [8/36]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s,
|  | size_type | __n2 )

inline

Definition at line 773 of file debug/string.

## replace() [9/36]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | size_type | __n2,
|  | _CharT | __c )

inline

Definition at line 792 of file debug/string.

## replace() [10/36]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::replace | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str )

inline

Definition at line 756 of file debug/string.

## replace() [11/36]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string & __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::replace | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 )

inline

Definition at line 764 of file debug/string.

## replace() [12/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | _CharT * | __k1,
|  | _CharT * | __k2 )

inline constexpr inherited

Definition at line 2653 of file basic_string.h.

## replace() [13/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | const _CharT * | __k1,
|  | const _CharT * | __k2 )

inline constexpr inherited

Definition at line 2665 of file basic_string.h.

## replace() [14/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | const _CharT * | __s )

inline constexpr inherited

Replace range of characters with C string.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __s | C string value to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the characters of __s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2572 of file basic_string.h.

## replace() [15/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | const _CharT * | __s,
|  | size_type | __n )

inline constexpr inherited

Replace range of characters with C substring.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __s | C string value to insert.
  __n | Number of characters from s to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the first __n characters of __s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2549 of file basic_string.h.

## replace() [16/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str )

inline constexpr inherited

Replace range of characters with string.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __str | String value to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the value of __str is inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2528 of file basic_string.h.

## replace() [17/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | const_iterator | __k1,
|  | const_iterator | __k2 )

inline constexpr inherited

Definition at line 2689 of file basic_string.h.

## replace() [18/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | iterator | __k1,
|  | iterator | __k2 )

inline constexpr inherited

Definition at line 2677 of file basic_string.h.

## replace() [19/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | size_type | __n,
|  | _CharT | __c )

inline constexpr inherited

Replace range of characters with multiple characters.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __n | Number of characters to insert.
  __c | Character to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, __n copies of __c are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2594 of file basic_string.h.

## replace() [20/36]

template<typename _CharT, typename _Traits, typename _Alloc>
template<class _InputIterator, typename = std::_RequireInputIter<_InputIterator>>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | const_iterator | __i1,
|  | const_iterator | __i2,
|  | _InputIterator | __k1,
|  | _InputIterator | __k2 )

inline constexpr inherited

Replace range of characters with range.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __k1 | Iterator referencing start of range to insert.
  __k2 | Iterator referencing end of range to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, characters in the range [__k1,__k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2622 of file basic_string.h.

## replace() [21/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | const_iterator | __i1,
|  | const_iterator | __i2,
|  | initializer_list< _CharT > | __l )

inline constexpr inherited

Replace range of characters with initializer_list.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __l | The initializer_list of characters to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, characters in the range [__k1,__k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2739 of file basic_string.h.

## replace() [22/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | _CharT * | __k1,
|  | _CharT * | __k2 )

inline inherited

Definition at line 2135 of file cow_string.h.

## replace() [23/36]

template<typename _CharT, typename _Traits, typename _Alloc>
template<class _InputIterator>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | _InputIterator | __k1,
|  | _InputIterator | __k2 )

inline inherited

Replace range of characters with range.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __k1 | Iterator referencing start of range to insert.
  __k2 | Iterator referencing end of range to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, characters in the range [__k1,__k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2122 of file cow_string.h.

## replace() [24/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const _CharT * | __k1,
|  | const _CharT * | __k2 )

inline inherited

Definition at line 2145 of file cow_string.h.

## replace() [25/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const _CharT * | __s )

inline inherited

Replace range of characters with C string.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __s | C string value to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the characters of __s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2077 of file cow_string.h.

## replace() [26/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const _CharT * | __s,
|  | size_type | __n )

inline inherited

Replace range of characters with C substring.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __s | C string value to insert.
  __n | Number of characters from s to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the first __n characters of __s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2056 of file cow_string.h.

## replace() [27/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str )

inline inherited

Replace range of characters with string.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __str | String value to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the value of __str is inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2037 of file cow_string.h.

## replace() [28/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const_iterator | __k1,
|  | const_iterator | __k2 )

inline inherited

Definition at line 2166 of file cow_string.h.

## replace() [29/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | initializer_list< _CharT > | __l )

inline inherited

Replace range of characters with initializer_list.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __l | The initializer_list of characters to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, characters in the range [__k1,__k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2212 of file cow_string.h.

## replace() [30/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | iterator | __k1,
|  | iterator | __k2 )

inline inherited

Definition at line 2156 of file cow_string.h.

## replace() [31/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | size_type | __n,
|  | _CharT | __c )

inline inherited

Replace range of characters with multiple characters.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __n | Number of characters to insert.
  __c | Character to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, __n copies of __c are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2098 of file cow_string.h.

## replace() [32/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos,
|  | size_type | __n,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str )

inline constexpr inherited

Replace characters with value from another string.

Parameters

  __pos | Index of first character to replace.
  __n | Number of characters to be replaced.
  __str | String to insert.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If pos is beyond the end of this string.
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__pos,__pos+__n) from this string. In place, the value of __str is inserted. If __pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2409 of file basic_string.h.

Referenced by std::basic_string< _CharT >::append(), std::basic_string< _CharT >::assign(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), and std::basic_string< _CharT >::replace().

## replace() [33/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s )

inline constexpr inherited

Replace characters with value of a C string.

Parameters

  __pos | Index of first character to replace.
  __n1 | Number of characters to be replaced.
  __s | C string to insert.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If pos > size().
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__pos,__pos + __n1) from this string. In place, the characters of __s are inserted. If __pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2484 of file basic_string.h.

## replace() [34/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s,
|  | size_type | __n2 )

inline constexpr inherited

Replace characters with value of a C substring.

Parameters

  __pos | Index of first character to replace.
  __n1 | Number of characters to be replaced.
  __s | C string to insert.
  __n2 | Number of characters from s to use.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If pos1 > size().
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__pos,__pos + __n1) from this string. In place, the first __n2 characters of __s are inserted, or all of __s if __n2 is too large. If __pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2458 of file basic_string.h.

## replace() [35/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | size_type | __n2,
|  | _CharT | __c )

inline constexpr inherited

Replace characters with multiple characters.

Parameters

  __pos | Index of first character to replace.
  __n1 | Number of characters to be replaced.
  __n2 | Number of characters to insert.
  __c | Character to insert.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If __pos > size().
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos + n1) from this string. In place, __n2 copies of __c are inserted. If __pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2509 of file basic_string.h.

## replace() [36/36]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 = npos )

inline constexpr inherited

Replace characters with value from another string.

Parameters

  __pos1 | Index of first character to replace.
  __n1 | Number of characters to be replaced.
  __str | String to insert.
  __pos2 | Index of first character of str to use.
  __n2 | Number of characters from str to use.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If __pos1 > size() or __pos2 > __str.size().
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__pos1,__pos1 + n) from this string. In place, the value of __str is inserted. If __pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2432 of file basic_string.h.

## reserve() [1/4]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

void std::basic_string< _CharT, _Traits, _Allocator >::reserve | ( |  | ) |

constexpr

Equivalent to shrink_to_fit().

## reserve() [2/4]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

void std::basic_string< _CharT, _Traits, _Allocator >::reserve | ( | size_type | __res_arg | ) |

constexpr

Attempt to preallocate enough memory for specified number of characters.

Parameters

  __res_arg | Number of characters required.

Exceptions

  std::length_error | If __res_arg exceeds `max_size()`.

This function attempts to reserve enough memory for the string to hold the specified number of characters. If the number requested is more than max_size(), length_error is thrown.

The advantage of this function is that if optimal code is a necessity and the user can determine the string length that will be required, the user can reserve the memory in advance, and thus prevent a possible reallocation of memory and copying of string data.

## reserve() [3/4]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

void std::basic_string< _CharT, _Traits, _Allocator >::reserve | ( | size_type | __res_arg | ) |

Attempt to preallocate enough memory for specified number of characters.

Parameters

  __res_arg | Number of characters required.

Exceptions

  std::length_error | If __res_arg exceeds `max_size()`.

This function attempts to reserve enough memory for the string to hold the specified number of characters. If the number requested is more than max_size(), length_error is thrown.

The advantage of this function is that if optimal code is a necessity and the user can determine the string length that will be required, the user can reserve the memory in advance, and thus prevent a possible reallocation of memory and copying of string data.

## reserve() [4/4]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::reserve | ( | size_type | __res_arg | ) |

constexpr inherited

Attempt to preallocate enough memory for specified number of characters.

Parameters

  __res_arg | Number of characters required.

Exceptions

  std::length_error | If __res_arg exceeds `max_size()`.

This function attempts to reserve enough memory for the string to hold the specified number of characters. If the number requested is more than max_size(), length_error is thrown.

The advantage of this function is that if optimal code is a necessity and the user can determine the string length that will be required, the user can reserve the memory in advance, and thus prevent a possible reallocation of memory and copying of string data.

Definition at line 3650 of file cow_string.h.

References capacity(), get_allocator(), and std::size().

Referenced by std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::tr2::operator>>(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow().

## resize() [1/4]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

void __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::resize | ( | size_type | __n | ) |

inline

Definition at line 340 of file debug/string.

## resize() [2/4]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

void __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::resize | ( | size_type | __n,
|  | _CharT | __c )

inline

Definition at line 333 of file debug/string.

## resize() [3/4]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::resize | ( | size_type | __n | ) |

inline constexpr inherited

Resizes the string to the specified number of characters.

Parameters

  __n | Number of characters the string should contain.

This function will resize the string to the specified length. If the new size is smaller than the string's current size the string is truncated, otherwise the string is extended and new characters are default-constructed. For basic types such as char, this means setting them to 0.

Definition at line 1215 of file basic_string.h.

## resize() [4/4]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::resize | ( | size_type | __n,
|  | _CharT | __c )

constexpr inherited

Resizes the string to the specified number of characters.

Parameters

  __n | Number of characters the string should contain.
  __c | Character to fill any new elements.

This function will resize the string to the specified number of characters. If the number is smaller than the string's current size the string is truncated, otherwise the string is extended and new elements are set to __c.

Definition at line 3798 of file cow_string.h.

References append(), erase(), and size().

Referenced by std::basic_string< _CharT >::resize().

## rfind() [1/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::rfind | ( | _CharT | __c,
|  | size_type | __pos = npos ) const

nodiscard constexpr noexcept

Find last position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for __c within this string. If found, returns the index where it was found. If not found, returns npos.

## rfind() [2/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::rfind | ( | _CharT | __c,
|  | size_type | __pos = npos ) const

noexcept

Find last position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for __c within this string. If found, returns the index where it was found. If not found, returns npos.

## rfind() [3/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::rfind | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

inline constexpr

Definition at line 931 of file debug/string.

## rfind() [4/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::rfind | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

nodiscard constexpr noexcept

Find last position of a C substring.

Parameters

  __s | C string to locate.
  __pos | Index of character to search back from.
  __n | Number of characters from s to search for.

Returns
  Index of start of last occurrence.

Starting from __pos, searches backward for the first __n characters in __s within this string. If found, returns the index where it begins. If not found, returns npos.

## rfind() [5/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::rfind | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

noexcept

Find last position of a C substring.

Parameters

  __s | C string to locate.
  __pos | Index of character to search back from.
  __n | Number of characters from s to search for.

Returns
  Index of start of last occurrence.

Starting from __pos, searches backward for the first __n characters in __s within this string. If found, returns the index where it begins. If not found, returns npos.

## rfind() [6/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::rfind | ( | const _CharT * | __s,
|  | size_type | __pos = _Base::npos ) const

inline constexpr

Definition at line 939 of file debug/string.

## rfind() [7/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::rfind | ( | const _CharT * | __s,
|  | size_type | __pos = npos ) const

inline nodiscard constexpr

Find last position of a C string.

Parameters

  __s | C string to locate.
  __pos | Index of character to start search at (default end).

Returns
  Index of start of last occurrence.

Starting from __pos, searches backward for the value of __s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 3056 of file basic_string.h.

## rfind() [8/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::rfind | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = npos ) const

inline nodiscard constexpr noexcept

Find last position of a string.

Parameters

  __str | String to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of start of last occurrence.

Starting from __pos, searches backward for value of __str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 3005 of file basic_string.h.

## rfind() [9/13]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::rfind | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = npos ) const

inline noexcept

Find last position of a string.

Parameters

  __str | String to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of start of last occurrence.

Starting from __pos, searches backward for value of __str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 2507 of file cow_string.h.

## rfind() [10/13]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::rfind | ( | _CharT | __c,
|  | size_type | __pos = npos ) const

nodiscard constexpr noexcept inherited

Find last position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for __c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 736 of file basic_string.tcc.

References npos, and std::size().

## rfind() [11/13]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::rfind | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const

nodiscard constexpr noexcept inherited

Find last position of a C substring.

Parameters

  __s | C string to locate.
  __pos | Index of character to search back from.
  __n | Number of characters from s to search for.

Returns
  Index of start of last occurrence.

Starting from __pos, searches backward for the first __n characters in __s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 713 of file basic_string.tcc.

References std::min(), npos, and std::size().

## rfind() [12/13]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::rfind | ( | const _CharT * | __s,
|  | size_type | __pos = npos ) const

inline nodiscard constexpr inherited

Find last position of a C string.

Parameters

  __s | C string to locate.
  __pos | Index of character to start search at (default end).

Returns
  Index of start of last occurrence.

Starting from __pos, searches backward for the value of __s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 3056 of file basic_string.h.

## rfind() [13/13]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::rfind | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = npos ) const

inline nodiscard constexpr noexcept inherited

Find last position of a string.

Parameters

  __str | String to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of start of last occurrence.

Starting from __pos, searches backward for value of __str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 3005 of file basic_string.h.

Referenced by std::basic_string< _CharT >::find_last_of(), std::basic_string< _CharT >::rfind(), std::basic_string< _CharT >::rfind(), std::basic_string< _CharT >::rfind(), and std::basic_string< _CharT >::rfind().

## shrink_to_fit()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

void __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::shrink_to_fit | ( |  | ) |

inline noexcept

Definition at line 345 of file debug/string.

## size()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Allocator >::size | ( |  | ) | const

inline nodiscard constexpr noexcept

Returns the number of characters in the string, not including any null-termination.

Definition at line 1163 of file basic_string.h.

## starts_with() [1/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::starts_with | ( | _CharT | __x | ) | const

inline nodiscard constexpr noexcept inherited

Definition at line 3719 of file basic_string.h.

## starts_with() [2/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::starts_with | ( | _CharT | __x | ) | const

inline noexcept inherited

Definition at line 3185 of file cow_string.h.

## starts_with() [3/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::starts_with | ( | basic_string_view< _CharT, _Traits > | __x | ) | const

inline nodiscard constexpr noexcept inherited

Definition at line 3714 of file basic_string.h.

## starts_with() [4/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::starts_with | ( | basic_string_view< _CharT, _Traits > | __x | ) | const

inline noexcept inherited

Definition at line 3181 of file cow_string.h.

## starts_with() [5/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::starts_with | ( | const _CharT * | __x | ) | const

inline nodiscard constexpr noexcept inherited

Definition at line 3724 of file basic_string.h.

## starts_with() [6/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::starts_with | ( | const _CharT * | __x | ) | const

inline noexcept inherited

Definition at line 3190 of file cow_string.h.

## substr() [1/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::substr | ( | size_type | __pos = 0,
|  | size_type | __n = _Base::npos ) const

inline

Definition at line 1025 of file debug/string.

## substr() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string std::basic_string< _CharT, _Traits, _Alloc >::substr | ( | size_type | __pos = 0,
|  | size_type | __n = npos ) const

inline nodiscard constexpr inherited

Get a substring.

Parameters

  __pos | Index of first character (default 0).
  __n | Number of characters in substring (default remainder).

Returns
  The new string.

Exceptions

  std::out_of_range | If __pos > size().

Construct and return a new string using the __n characters starting at __pos. If the string is too short, use the remainder of the characters. If __pos is beyond the end of the string, out_of_range is thrown.

Definition at line 3441 of file basic_string.h.

## swap() [1/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

void __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::swap | ( | basic_string< _CharT, _Traits, _Allocator > & | __x | ) |

inline noexcept

Definition at line 882 of file debug/string.

## swap() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::swap | ( | basic_string< _CharT, _Traits, _Alloc > & | __s | ) |

constexpr noexcept inherited

Swap contents with another string.

Parameters

  __s | String to swap with.

Exchanges the contents of this string with that of __s in constant time.

Definition at line 3676 of file cow_string.h.

References basic_string(), and get_allocator().

Referenced by std::basic_string< _CharT >::assign(), and std::basic_string< _CharT >::operator=().

## Friends And Related Symbol Documentation

## ::__gnu_debug::_Safe_iterator

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>
template<typename _ItT, typename _SeqT, typename _CatT>

friend class ::__gnu_debug::_Safe_iterator

friend

Definition at line 143 of file debug/string.

## Member Data Documentation

## _M_allocated_capacity

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::_M_allocated_capacity

inherited

Definition at line 223 of file basic_string.h.

## _M_local_buf

template<typename _CharT, typename _Traits, typename _Alloc>

_CharT std::basic_string< _CharT, _Traits, _Alloc >::_M_local_buf[_S_local_capacity+1]

inherited

Definition at line 222 of file basic_string.h.

## npos

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const size_type std::basic_string< _CharT, _Traits, _Allocator >::npos

static

Value returned by various member functions when they fail.

Definition at line 128 of file basic_string.h.

The documentation for this class was generated from the following file:

- debug/string